// geometry.h
// DEFINOVANIE ZAKLADNYCH GEOMETRICKYCH OBJEKTOV

// GLEW kniznica. pre spravu novsich rozsireni
#include "glew.h"

// priprava VBO pre renderovanie kocky
void initCubeVBO();

// priprava VBO pre renderovanie sfery
void initSphereVBO(int xSlices, int ySlices);

// priprava VBO pre renderovanie torusu
void initTorusVBO(float innerRadius, float outerRadius, int xSlices, int ySlices);

// vykresli jednotkovu kocku s pomocou pripravenych VBO
void renderCubeVBO(GLuint shader_program);

// vykresli jednotkovu sferu s pomocou pripravenych VBO
void renderSphereVBO(GLuint shader_program);

// vykresli torus s pomocou pripravenych VBO
void renderTorusVBO(GLuint shader_program);

// vycitime alokovane objekty
void DeleteAllVBO();

// funkcia na vypocet tangent pre kazy vrchol na zaklade pozicii a texturnych koordinat vrcholov
// vo vysledku su tangenty znormalizovane, kolme na normalu, so stvrtou suradnicou obsahujucou informaciu od orientacii tangencialneho priestoru
void CalculateTangentArray(GLuint num_vertices, float* vertices_3D, float* normals_3D,
        float* texcoords_2D, GLenum polygon_mode, int num_indices, GLuint* indices, float* final_tangents_4D);