varying vec3 N_eye;
varying float linear_depth_eye;

uniform sampler2D diffuse_map;
uniform int texturing_enabled;

vec4 pack_depth(float depth)
{
    const vec4 bit_shift = vec4(256.0*256.0*256.0, 256.0*256.0, 256.0, 1.0);
    const vec4 bit_mask  = vec4(0.0, 1.0/256.0, 1.0/256.0, 1.0/256.0);
    vec4 res = fract(depth * bit_shift);
    res -= res.xxyz * bit_mask;
    return res;
}

void main(void)
{
   vec4 diffuse_material = gl_FrontMaterial.diffuse;
   if (texturing_enabled > 0)
       diffuse_material = texture2D(diffuse_map, gl_TexCoord[0].st);

   gl_FragData[0] = diffuse_material;
   gl_FragData[1] = vec4(0.5 * N_eye.xyz + 0.5, linear_depth_eye);
   gl_FragData[2] = pack_depth(linear_depth_eye);
}

