uniform mat4 light_view_matrix;
uniform mat4 light_proj_matrix;
uniform mat4 camera_view_matrix;
		
varying vec4 V_eye;
varying vec4 L_eye;
varying vec4 N_eye;
varying vec4 shadow_map_tex_coords;

void main(void)
{
   V_eye = camera_view_matrix * gl_ModelViewMatrix * gl_Vertex;
   L_eye = gl_LightSource[0].position - V_eye;
   N_eye = camera_view_matrix * gl_ModelViewMatrix * vec4(gl_Normal, 0.0);
   
   shadow_map_tex_coords = light_proj_matrix * light_view_matrix * gl_ModelViewMatrix * gl_Vertex;
   shadow_map_tex_coords = 0.5 * shadow_map_tex_coords / shadow_map_tex_coords.w + 0.5;

   gl_TexCoord[0] = gl_MultiTexCoord0;
   gl_Position = gl_ProjectionMatrix * V_eye;
   V_eye = -V_eye;
}

